require '_h2ph_pre.ph';

require 'sys/queue.ph';
unless(defined(&RTM_RTTUNIT)) {
    sub RTM_RTTUNIT () {	1000000;}
}
unless(defined(&RTTTOPRHZ)) {
    sub RTTTOPRHZ {
	local($r) = @_;
	eval q((($r) / ( &RTM_RTTUNIT /  &PR_SLOWHZ)));
    }
}
unless(defined(&RNF_NORMAL)) {
    require 'net/radix.ph';
}
unless(defined(&rt_key)) {
    sub rt_key {
	local($r) = @_;
	eval q(((($r)-> ($rt_nodes->{rn_key}))));
    }
}
unless(defined(&rt_mask)) {
    sub rt_mask {
	local($r) = @_;
	eval q(((($r)-> ($rt_nodes->{rn_mask}))));
    }
}
unless(defined(&rt_use)) {
    sub rt_use () {	 ($rt_rmx->{rmx_pksent});}
}
unless(defined(&RTF_UP)) {
    sub RTF_UP () {	0x1;}
}
unless(defined(&RTF_GATEWAY)) {
    sub RTF_GATEWAY () {	0x2;}
}
unless(defined(&RTF_HOST)) {
    sub RTF_HOST () {	0x4;}
}
unless(defined(&RTF_REJECT)) {
    sub RTF_REJECT () {	0x8;}
}
unless(defined(&RTF_DYNAMIC)) {
    sub RTF_DYNAMIC () {	0x10;}
}
unless(defined(&RTF_MODIFIED)) {
    sub RTF_MODIFIED () {	0x20;}
}
unless(defined(&RTF_DONE)) {
    sub RTF_DONE () {	0x40;}
}
unless(defined(&RTF_MASK)) {
    sub RTF_MASK () {	0x80;}
}
unless(defined(&RTF_CLONING)) {
    sub RTF_CLONING () {	0x100;}
}
unless(defined(&RTF_XRESOLVE)) {
    sub RTF_XRESOLVE () {	0x200;}
}
unless(defined(&RTF_LLINFO)) {
    sub RTF_LLINFO () {	0x400;}
}
unless(defined(&RTF_STATIC)) {
    sub RTF_STATIC () {	0x800;}
}
unless(defined(&RTF_BLACKHOLE)) {
    sub RTF_BLACKHOLE () {	0x1000;}
}
unless(defined(&RTF_PROTO3)) {
    sub RTF_PROTO3 () {	0x2000;}
}
unless(defined(&RTF_PROTO2)) {
    sub RTF_PROTO2 () {	0x4000;}
}
unless(defined(&RTF_PROTO1)) {
    sub RTF_PROTO1 () {	0x8000;}
}
unless(defined(&RTF_TUNNEL)) {
    sub RTF_TUNNEL () {	0x100000;}
}
unless(defined(&RTM_VERSION)) {
    sub RTM_VERSION () {	3;}
}
unless(defined(&RTM_ADD)) {
    sub RTM_ADD () {	0x1;}
}
unless(defined(&RTM_DELETE)) {
    sub RTM_DELETE () {	0x2;}
}
unless(defined(&RTM_CHANGE)) {
    sub RTM_CHANGE () {	0x3;}
}
unless(defined(&RTM_GET)) {
    sub RTM_GET () {	0x4;}
}
unless(defined(&RTM_LOSING)) {
    sub RTM_LOSING () {	0x5;}
}
unless(defined(&RTM_REDIRECT)) {
    sub RTM_REDIRECT () {	0x6;}
}
unless(defined(&RTM_MISS)) {
    sub RTM_MISS () {	0x7;}
}
unless(defined(&RTM_LOCK)) {
    sub RTM_LOCK () {	0x8;}
}
unless(defined(&RTM_OLDADD)) {
    sub RTM_OLDADD () {	0x9;}
}
unless(defined(&RTM_OLDDEL)) {
    sub RTM_OLDDEL () {	0xa;}
}
unless(defined(&RTM_RESOLVE)) {
    sub RTM_RESOLVE () {	0xb;}
}
unless(defined(&RTM_NEWADDR)) {
    sub RTM_NEWADDR () {	0xc;}
}
unless(defined(&RTM_DELADDR)) {
    sub RTM_DELADDR () {	0xd;}
}
unless(defined(&RTM_IFINFO)) {
    sub RTM_IFINFO () {	0xe;}
}
unless(defined(&RTV_MTU)) {
    sub RTV_MTU () {	0x1;}
}
unless(defined(&RTV_HOPCOUNT)) {
    sub RTV_HOPCOUNT () {	0x2;}
}
unless(defined(&RTV_EXPIRE)) {
    sub RTV_EXPIRE () {	0x4;}
}
unless(defined(&RTV_RPIPE)) {
    sub RTV_RPIPE () {	0x8;}
}
unless(defined(&RTV_SPIPE)) {
    sub RTV_SPIPE () {	0x10;}
}
unless(defined(&RTV_SSTHRESH)) {
    sub RTV_SSTHRESH () {	0x20;}
}
unless(defined(&RTV_RTT)) {
    sub RTV_RTT () {	0x40;}
}
unless(defined(&RTV_RTTVAR)) {
    sub RTV_RTTVAR () {	0x80;}
}
unless(defined(&RTA_DST)) {
    sub RTA_DST () {	0x1;}
}
unless(defined(&RTA_GATEWAY)) {
    sub RTA_GATEWAY () {	0x2;}
}
unless(defined(&RTA_NETMASK)) {
    sub RTA_NETMASK () {	0x4;}
}
unless(defined(&RTA_GENMASK)) {
    sub RTA_GENMASK () {	0x8;}
}
unless(defined(&RTA_IFP)) {
    sub RTA_IFP () {	0x10;}
}
unless(defined(&RTA_IFA)) {
    sub RTA_IFA () {	0x20;}
}
unless(defined(&RTA_AUTHOR)) {
    sub RTA_AUTHOR () {	0x40;}
}
unless(defined(&RTA_BRD)) {
    sub RTA_BRD () {	0x80;}
}
unless(defined(&RTAX_DST)) {
    sub RTAX_DST () {	0;}
}
unless(defined(&RTAX_GATEWAY)) {
    sub RTAX_GATEWAY () {	1;}
}
unless(defined(&RTAX_NETMASK)) {
    sub RTAX_NETMASK () {	2;}
}
unless(defined(&RTAX_GENMASK)) {
    sub RTAX_GENMASK () {	3;}
}
unless(defined(&RTAX_IFP)) {
    sub RTAX_IFP () {	4;}
}
unless(defined(&RTAX_IFA)) {
    sub RTAX_IFA () {	5;}
}
unless(defined(&RTAX_AUTHOR)) {
    sub RTAX_AUTHOR () {	6;}
}
unless(defined(&RTAX_BRD)) {
    sub RTAX_BRD () {	7;}
}
unless(defined(&RTAX_MAX)) {
    sub RTAX_MAX () {	8;}
}
if(defined(&_KERNEL)) {
    eval 'sub RTFREE {
        local($rt) = @_;
	    eval q( &do {  &if (($rt)-> &rt_refcnt <= 1)  &rtfree($rt);  &else ($rt)-> &rt_refcnt--; }  &while (0));
    }' unless defined(&RTFREE);
    eval 'sub ALL_CLONING () {0;}' unless defined(&ALL_CLONING);
    eval 'sub ONNET_CLONING () {1;}' unless defined(&ONNET_CLONING);
    eval 'sub NO_CLONING () {2;}' unless defined(&NO_CLONING);
}
1;
